structure Test = 
struct
  val DEBUG = false

  val N_CHOICES = 4  (* do not change this constant *)

  exception BadConfiguration
  exception N_CHOICESMustBeFour
  
  (** Change this function to return a random tree that evalutes to n **)
  fun randomTree (depth,maxNum)  n = Ast.Num 1

  fun selfCheck (maxDepth,maxNum) = 
    if ((maxDepth) > 0) andalso ((maxNum) > 0) then
	()
    else
	(print "maxDepth and maxNum must be positive\n";
	 raise BadConfiguration)
       
  fun test (maxDepth,maxNum) n = 
    let  
        (** Change the depth to be a random positive value between 0 and maxDepth -1 **)
        val depth = 1
	val t = randomTree (depth,maxNum) n
        val _ = print ("tree = " ^ Ast.toString t ^ "\n")
	val _ = print ("tree = " ^ Ast.toPrettyString t ^ "\n")
	val r = Ast.eval (t)
	val _ = print ("eval(tree) = " ^ Int.toString  r ^ "\n")
    in 
	r
    end

  fun mkTree (maxDepth, maxNum) (n:int) = 
      let
	  val _ = selfCheck (maxDepth,maxNum)
      in
	  test  (maxDepth,maxNum) n
      end

end
